//+------------------------------------------------------------------+
//|                                                   ay-MP-Text.mq4 |
//|                      Copyright  2011, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2011, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

#property indicator_chart_window
/********************************************************************\\\
 * MP Library 
 * dont change anything in this mp library block, unless.....
 ********************************************************************///say something here...
#define MP_PRICE                 0                                  // 
#define MP_TPO                   1                                  //
#define MP_VOL                   2                                  //
                                                                    //
#define MPL_POCTPO               0                                  //
#define MPL_POCVOL               1                                  //
#define MPL_TPOVAH               2                                  //
#define MPL_TPOVAL               3                                  //
#define MPL_VOLVAH               4                                  //
#define MPL_VOLVAL               5                                  //
                                                                    //
#define MPT_TPO                  0                                  //
#define MPT_VOL                  1                                  //
                                                                    //
#define MPSIZE                   3                                  // 2nd dim mpdata array size
#define MPLNSIZE                 6                                  // 1st dim mplines array size
#define MPTSIZE                  2                                  // 1st dim mptotal array size
#define MPLTSIZE                 512                                // 2nd dim mpletter array size
                                                                    //
#import "ay-mt4mplibl.dll"                                          //
void getMPData                                                      //
   (                                                                //
        double    hh                                                //
      , double    ll                                                //
      , double    onetick                                           //
      , int       startbar                                          //
      , int       endbar                                            //       
      , double    vapercent                                         //
      , double    arates[][6]                                       //
      , int       ratessize                                         //
      , double&   mpdata[][MPSIZE]                                  //
      , int       mpdatasize                                        //
      , int&      mplines[]                                         //
      , double&   mptotal[]                                         //
      , int&      mpletter[][MPLTSIZE] 	                          //
   );                                                               //
#import                                                             //
/*******************************************************************\\\
 * End MP Library 
 *******************************************************************///


 
#define PERIOD_Y1 518400 
 
extern int        LookBack                = 10;
extern string     ProfileTimeframeInfo    = "use D, W, M, or Y";
extern string     ProfileTimeframe        = "D";
extern int        DayStartHour            = 0;
extern int        TextHeightInPips        = 5;
extern double     VAPercent               = 70.0;
extern bool       ShowProfileInfo         = true;
extern string     spr1                    = "Colors.............";
extern color      LetterColor             = Silver;
extern color      VAColor                 = C'0,16,16';
extern color      POCColor                = C'0,96,96';
extern color      BarBullColor            = Navy;
extern color      BarBearColor            = Maroon;
extern color      BarNetralColor          = DimGray;
extern color      CurrentLetterColor      = LimeGreen;

extern string     spr2                    = "Profile Data.............";
extern int        DailyProfileDataTf      = 30;
extern int        WeeklyProfileDataTf     = 30;
extern int        MonthlyProfileDataTf    = 60;
extern int        YearlyProfileDataTf     = 1440;


int      giDigits;
int      giDataTf;//      = PERIOD_M30;
int      giProfileTf;//   = PERIOD_D1;
int      giStep;      //  = 5;

double   gdPoint
       , gdTextHeight
       , gdOneTick
       , gdTickSize
       , gdaRates[][6];
       
string  gsaLetter[] = 
   {
    "A","B","C","D","E","F","G","H","I","J","K","L","M","N","O","P","Q","R","S","T","U","P","W","X","Y","Z"
   ,"a","b","c","d","e","f","g","h","i","j","k","l","m","n","o","p","q","r","s","t","u","p","w","x","y","z"
   };
   
string  gsPref = "ay.mpletter.";

#include <ay-object.func.mqh>       
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
{

   if (Point == 0.001 || Point == 0.00001) 
   { gdPoint = Point*10; giDigits = Digits - 1; }
   else 
   { gdPoint = Point; giDigits = Digits; }     
   
   gdOneTick = 1/MathPow(10, giDigits);
      
   setConfig();
      
   return(0);
}

void setConfig()
{

//---   
   if (ProfileTimeframe == "Y" )   
   {
      giProfileTf = PERIOD_Y1;     
      giDataTf    = YearlyProfileDataTf;
   }   
   else
   if (ProfileTimeframe == "M" )   
   {
      giProfileTf = PERIOD_MN1;     
      giDataTf    = MonthlyProfileDataTf;
   }   
   else 
   if (ProfileTimeframe == "W" )
   {
      giProfileTf = PERIOD_W1;     
      giDataTf    = WeeklyProfileDataTf;
   }
   else //default D1
   {
      giProfileTf = PERIOD_D1;
      giDataTf    = DailyProfileDataTf;      
   }   
   
   giStep = MathMax(TextHeightInPips, 5);

   ArrayCopyRates(gdaRates, NULL, giDataTf);

}
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
{

   return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
{
      
   if (!isHistOK()) return(0);
   
   
   int        ibar.proftf, startbar, endbar;
   double     hh, ll, poc, vah, val, open, close; 
       
   double     mpdata  [][MPSIZE];
   int        mplines   [MPLNSIZE];
   double     mptotal   [MPTSIZE];
   int        mpletter[][MPLTSIZE];
   
   int        ratessize = iBars(NULL, giDataTf)
            , mpdatasize
            , maxtpo
            , maxlook = 1
            , startprofile
            , laststartprofile = 0
            , space = 5;      
            
   //redraw all profile on newbar data
   //else redraw only #0 profile
   if ( newBarDataTf() ) 
   {
      delObjs();
      maxlook = LookBack;
   }
   //else delObjs(gsPref + "#0");
   
   
      
   for (ibar.proftf=0; ibar.proftf<maxlook; ibar.proftf++)
   {
      getStartAndEndBar(ibar.proftf, startbar, endbar);          
      
      getHHLL
      (
           giDataTf        //int       tf
         , startbar        //int       sb
         , endbar          //int       eb
         , hh              //double&   hh
         , ll              //double&   ll
      );      
                                
      mpdatasize = MathRound((hh - ll)/gdOneTick) + 1;
      ArrayResize(mpdata, mpdatasize); 
      ArrayResize(mpletter, mpdatasize);   
      ArrayInitialize(mpdata,0.0); 
      ArrayInitialize(mpletter,-1); 
      ArrayInitialize(mplines,0);
      ArrayInitialize(mptotal,0.0);
            
      getMPData
         (
           hh           , ll           
         , gdOneTick
         , startbar     , endbar       
         , VAPercent
         , gdaRates     , ratessize       
         , mpdata       , mpdatasize  
         , mplines      , mptotal 
         , mpletter   	   
         );    
         
      maxtpo = mpdata[ mplines[MPL_POCTPO] ][MP_TPO];   
      
      startprofile      = laststartprofile + maxtpo + space;      
      laststartprofile  = startprofile;
      
      open  = iOpen(NULL, giDataTf, startbar);
      close = iClose(NULL, giDataTf, endbar);      
      drawBar( ibar.proftf, startprofile+2, open, hh, ll, close );
      
      createRect( "#"+ibar.proftf+".va" 
         , mpdata[ mplines[MPL_TPOVAH] ][MP_PRICE], Time[ startprofile + 1 ]
         , mpdata[ mplines[MPL_TPOVAL] ][MP_PRICE], Time[ startprofile - (maxtpo+1) ]
         , VAColor );          
      createTl("#" + ibar.proftf + ".poc"
         , Time[ startprofile + 1 ]         , mpdata[ mplines[MPL_POCTPO] ][MP_PRICE]
         , Time[ startprofile - (maxtpo+1) ], mpdata[ mplines[MPL_POCTPO] ][MP_PRICE]
         , POCColor, STYLE_SOLID, 3
         );      
                   
      //redraw #0 profile letter only every 5 second
      if ( ibar.proftf==0 )
         if ( !secondDiff(5) ) continue;      
         else delObjs(gsPref + "#0.letter.");       
                 
      drawPriceLetter
      (
           ibar.proftf        //int    ibar.proftf
         , startprofile       //int    sbprofile
         , startbar - endbar  //int totalbar
         , mpdatasize         //int    mpdatasize           
         , mpdata             //double mpdata[][]
         , mplines            //int    mplines[]
         , mpletter           //int    mpletter[][]
      );            
      
      if (!ShowProfileInfo) continue;
      createText( "#" + ibar.proftf + ".info1"   
         , Time[ (startprofile - (maxtpo)/2) ]
         , hh + ( (giStep/1.0) * gdPoint ) * 5
         , TimeToStr(iTime(NULL, giDataTf, startbar))
         , 8, "Lucida Console", POCColor
         );
      createText( "#" + ibar.proftf + ".info2"   
         , Time[ (startprofile - (maxtpo)/2) ]
         , hh + ( (giStep/1.0) * gdPoint ) * 4
         , addStr("VAH: " + DoubleToStr(mpdata[ mplines[MPL_VOLVAH] ][MP_PRICE], giDigits), " ", 16, false)
         , 8, "Lucida Console", POCColor
         );         
      createText( "#" + ibar.proftf + ".info3"   
         , Time[ (startprofile - (maxtpo)/2) ]
         , hh + ( (giStep/1.0) * gdPoint ) * 3
         , addStr("POC: " + DoubleToStr(mpdata[ mplines[MPL_POCTPO] ][MP_PRICE], giDigits), " ", 16, false)
         , 8, "Lucida Console", POCColor
         );      
      createText( "#" + ibar.proftf + ".info4"   
         , Time[ (startprofile - (maxtpo)/2) ]
         , hh + ( (giStep/1.0) * gdPoint ) * 2
         , addStr("VAL: " + DoubleToStr(mpdata[ mplines[MPL_VOLVAL] ][MP_PRICE], giDigits), " ", 16, false)
         , 8, "Lucida Console", POCColor
         );       
   }
   
   drawSettingInfo();
   
   
   return(0);
}
/**
 *
 */
void drawSettingInfo()
{
   
   int x=10, y=10;
   
   lblCreate("info1", x, y, "ProfileTf : " + ProfileTimeframe, 1, LetterColor); 
   
   y+=12;
   lblCreate("info2", x, y, "ProfileDataTf : " + giDataTf + " Minutes", 1, LetterColor);
    
   y+=12;
   lblCreate("info3", x, y, "TextHeight : " + TextHeightInPips + " pips", 1, LetterColor); 
   
   if (ProfileTimeframe == "D")
   {
      y+=12;
      lblCreate("info4", x, y, "DayStartHour : " + DayStartHour , 1, LetterColor);    
   }   
   
}
/**
 *
 */
void drawBar( int barnum, int pos, double o, double h, double l, double c )
{
   color barclr;
   if (c>o)barclr=BarBullColor; else
   if (c<o)barclr=BarBearColor; else
           barclr=BarNetralColor;   

   createTl("#" + barnum + ".bar.spread"
      , Time[pos], h
      , Time[pos], l
      , barclr, STYLE_SOLID, 2
      );            
   
   createTl("#" + barnum + ".bar.o"
      , Time[pos+1], o
      , Time[pos], o
      , barclr, STYLE_SOLID, 2, false
      ); 
      
   createTl("#" + barnum + ".bar.c"
      , Time[pos-1], c
      , Time[pos], c
      , barclr, STYLE_SOLID, 2, false
      );       
}
//+------------------------------------------------------------------+
//| getStartAndEndBar                                                |
//+------------------------------------------------------------------+
void getStartAndEndBar(int ibar.proftf, int &startbar, int &endbar)
{      
   
   int i, j;
   datetime dt.proftf;     
   datetime dt.proftf.next; 
      
   switch (giProfileTf)
   {
      case PERIOD_D1:

         startbar = 0; endbar = 0;     
             
         int dsh     = DayStartHour;
         int oneday  = (PERIOD_D1*60) - 1; // -1 is for .... like 23:59:xxxx
         int idsh    = dsh * PERIOD_H1 * 60;
   
         datetime dt.htf, dt.starthour, dt.endhour;
         int  sb = 0       //startbar
            , eb = 0;      //endbar            
         
         if ( TimeHour(iTime(NULL, giDataTf, 0)) < dsh) ibar.proftf++;
   
         dt.htf       = iTime( NULL, giProfileTf, ibar.proftf ); 
         dt.starthour = dt.htf + idsh;  
         dt.endhour   = dt.starthour + oneday;
         
         if ( TimeDayOfWeek(dt.endhour) == 6 ) 
         {
            dt.endhour += (2*oneday);         
         }
                     
         sb  = iBarShift ( NULL, giDataTf, dt.starthour ); 
         eb  = iBarShift ( NULL, giDataTf, dt.endhour ); 
   
         //missing hour
         if ( iTime(NULL, giDataTf, sb) < dt.starthour )
         {
            //use the next bar for startbar
            sb--;     
          
            dt.endhour = StrToTime( TimeToStr(iTime( NULL, giDataTf, sb), TIME_DATE) ) + idsh - 1;
            
            if ( dt.endhour <= iTime( NULL, giDataTf, sb) ) dt.endhour += oneday;
      
            eb = iBarShift( NULL, giDataTf, dt.endhour );         
         }
                  
         startbar = sb;
         endbar   = eb;         
                                                  
      break;
      
      case PERIOD_Y1:
         int year       = TimeYear(Time[0]) - ibar.proftf;
         dt.proftf      = StrToTime(year + ".01.01 00:00");
         dt.proftf.next = StrToTime(year + ".12.31 23:59");
         
         startbar  = iBarShift ( NULL, giDataTf, dt.proftf);
         endbar    = iBarShift ( NULL, giDataTf, dt.proftf.next);  
                  
         if ( iTime(NULL, giDataTf, startbar) < dt.proftf ) startbar--; 
                  
      break;        
      
      default:
         dt.proftf      = iTime( NULL, giProfileTf, ibar.proftf );
         dt.proftf.next = iTime( NULL, giProfileTf, ibar.proftf - 1 );
         
         startbar  = iBarShift ( NULL, giDataTf, dt.proftf);
         endbar    = iBarShift ( NULL, giDataTf, dt.proftf.next - (giDataTf * 60) );
         //current week, month         
         if (dt.proftf.next < dt.proftf) endbar = 0;         
         // fix ibarshift on month\week start
         if ( iTime(NULL, giDataTf, startbar) < dt.proftf ) startbar--;    
                           
      break;
   }         
}

/**
 *
 */
void drawPriceLetter
(
     int    ibar.proftf
   , int    sbprofile
   , int    totalbar
   , int    mpdatasize           
   , double mpdata[][]
   , int    mplines[]
   , int    mpletter[][]
)
{          
   
   int      maxtpoidx      = mplines[MPL_POCTPO];
   double   maxtpo         = mpdata[maxtpoidx][MP_TPO];
           
   double   price1, price2, dstep;
   //int        inumtpo; 
   double     numtpo, numvol;
   int        step, step2, stepl, i, j, pos
            , letterid;
   string     letter;
   //double   lprice         = mpdata[mpdatasize-1][0]; 
   //int      midmpdatasize  = MathRound((mpdatasize-1)/2);
   color    clr;
   
   for (step = 0; step<mpdatasize; step += (giStep-1))
   {
      price1   = mpdata[ step ][MP_PRICE];
      step2    = MathMin(step+giStep, mpdatasize-1);
      price2   = mpdata[ step2 ][MP_PRICE];  
      
      numtpo   = 0;            
      for (i=step; i < step2; i++)
      {         
        if (  mpdata[i][MP_TPO] > numtpo)
        {
            numtpo = mpdata[i][MP_TPO];
            stepl = i;
        } 
      }   

      pos = sbprofile;
      for (j=0; j<512; j++)
      {
         if ( mpletter[stepl][j] == -1) break;
         
         letterid =  mpletter[stepl][j] ;
         if (letterid>50) letterid = MathMod(letterid,50);
         
         letter = gsaLetter[ letterid ];
         
         if ( ibar.proftf == 0 && letterid == totalbar )
            clr = CurrentLetterColor;
         else clr = LetterColor; 
         
         createText( "#" + ibar.proftf + ".letter." + step + "-" + j
            , Time[pos]
            , price1
            , letter
            , 8, "Lucida Console", clr
            );          
         
         pos--;
      }
      
   }
   
      
}
/**
 *getHHLL                                                          
*/
void getHHLL
(
     int       tf
   , int       sb
   , int       eb
   , double&   hh
   , double&   ll
)
{
   hh = iHigh ( NULL, tf, iHighest(NULL, tf, MODE_HIGH, (sb-eb)+1, eb) );
   ll = iLow  ( NULL, tf, iLowest (NULL, tf, MODE_LOW,  (sb-eb)+1, eb) );
} 
//+------------------------------------------------------------------+
//| secondDiff                                                       |
//+------------------------------------------------------------------+ 
bool secondDiff(int sec = 10)
{
   static datetime lasttime ;
   int diff = TimeCurrent() - lasttime ;

   if (diff > sec )
   {
      lasttime = TimeCurrent();
      return (true);
   }
   
   return (false);
   
} 

bool newBarDataTf()
{
   static datetime LastBar;
   datetime CurrBar = iTime(NULL, giDataTf, 0);

   if(LastBar != CurrBar)
   {
      LastBar = CurrBar;
      return (true);
   }
   return(false);  

}
//+------------------------------------------------------------------+
//| addStr                                                          |
//+------------------------------------------------------------------+ 
string addStr(string str, string char, int maxlength, bool atbeginning = true)
{
   int l = maxlength - StringLen(str);
   for (int i=0; i<l; i++)
   {
      if (atbeginning) str = char + str;
      else str = str + char;
   }
      
   return(str);
}
/*
 *isOK
 *check history
*/
bool isHistOK()
{
   //check for error history in ProfileDataTf   
   int preverr   = GetLastError();
   int checkibar = iBars(NULL, giDataTf);
   int lasterr   = GetLastError();
   
   if (lasterr != 0 && lasterr != preverr) 
   {
      Print("isOK()::iBars(NULL, ProfileDataTf) lasterr ", lasterr);
      return(false);      
   }   
   
   //check for error history in current chart period
   preverr   = lasterr;
   checkibar = iBars(NULL, Period());
   lasterr   = GetLastError();   
   if (lasterr != 0 && lasterr != preverr) 
   {
      Print("isOK()::iBars(NULL, Period()) lasterr ", lasterr);
      return(false);      
   }    
   
   return(true);

}

//+------------------------------------------------------------------+